#if !defined(AFX_WINSTACK_H__4CA4B546_3503_11D3_AA67_00A024AABB2F__INCLUDED_)
#define AFX_WINSTACK_H__4CA4B546_3503_11D3_AA67_00A024AABB2F__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// winstack.h : header file
//

#define LWM_CALCPANELSIZE WM_APP+400


/////////////////////////////////////////////////////////////////////////////
// CStackWnd window

// stack window page flags
#define SWF_VISIBLE     0x0001
#define SWF_CONTRACTED  0x0002

class CStackWnd : public CWnd
{
   DECLARE_DYNCREATE(CStackWnd)

// Construction
public:
	CStackWnd();

// Attributes
public:

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CStackWnd)
	public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
	protected:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CStackWnd();

   BOOL InsertPage(CDialog* pDlg, LPCTSTR lpszTemplate, LPCTSTR lpszCaption, 
      DWORD dwFlags = SWF_VISIBLE, int nPage = -1);
   BOOL InsertPage(CDialog* pDlg, UINT nIDTemplate, LPCTSTR lpszCaption,
      DWORD dwFlags = SWF_VISIBLE, int nPage = -1);
   virtual void DrawPageCaption(CDC* pDC, LPCTSTR lpszText, 
      UINT nState, LPRECT lpRect);

// Layout information
public:

   CSize m_sizeMin;

protected:

   struct CPageInfo
   {
      CPageInfo();

      CDialog*    m_pDlg;
      LPCTSTR     m_lpszTemplate;
      CSize       m_sizeDlg;
      CRect       m_rectPage;
      DWORD       m_dwFlags;
      LPCTSTR     m_lpszText;
      CPageInfo*  m_pNext;
   };

   CPageInfo*  m_pPageInfo;
   CPageInfo*  m_pPageInfoTemp;
   int         m_nPageCount;

   CPoint      m_ptWnd;
   CSize       m_sizeClient;
   CSize       m_sizeStack;
   int         m_cyCaption;
   int         m_cyGap;

   BOOL        m_bPanning;
   int         m_xOrigin;
   int         m_yOrigin;

   HCURSOR     m_hCurPan;
   HCURSOR     m_hCurDefault;
   CPoint      m_ptSave;
   BOOL        m_bCurPan;

   CBrush      m_dottedBrush;

   void RecalcLayout(BOOL bRepositionPages = TRUE);
   void SetPageState(CPageInfo* pInfo, BOOL bShow, BOOL bContract, BOOL bEnsureVisible = TRUE);
   int InsertPageInfo(CPageInfo* pInfo, int nPage);
   void ClearPageInfo();
   BOOL IsPage(HWND hWnd);
   CPageInfo* CaptionHitTest(POINT pt);
   void CalcCaptionRect(CPageInfo* pInfo, LPRECT lpRect);
   BOOL IsPanEnabled(BOOL bPanX = TRUE, BOOL bPanY = TRUE);
   BOOL BeginPanning(POINT pt);
   void ContinuePanning(POINT pt);
   void EndPanning();
   BOOL DelayedShowPanCursor(BOOL bShow = FALSE);
   BOOL BeginCaptionPress(POINT point);
   void CreateDottedBrush();

	// Generated message map functions
protected:
	//{{AFX_MSG(CStackWnd)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnPaint();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg BOOL OnSetCursor(CWnd* pWnd, UINT nHitTest, UINT message);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnWindowPosChanged(WINDOWPOS FAR* lpwndpos);
	afx_msg void OnCancelMode();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	//}}AFX_MSG
   afx_msg LRESULT OnCalcPanelSize(WPARAM wParam, LPARAM lParam);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_WINSTACK_H__4CA4B546_3503_11D3_AA67_00A024AABB2F__INCLUDED_)
